diff -pruN 6.0.0-2/.kde-ci.yml 6.3.0-1/.kde-ci.yml
--- 6.0.0-2/.kde-ci.yml	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/.kde-ci.yml	2024-05-31 13:24:05.000000000 +0000
@@ -5,3 +5,4 @@ Dependencies:
 
 Options:
   test-before-installing: True
+  require-passing-tests-on: [ 'Linux', 'Windows' ]
diff -pruN 6.0.0-2/CMakeLists.txt 6.3.0-1/CMakeLists.txt
--- 6.0.0-2/CMakeLists.txt	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/CMakeLists.txt	2024-05-31 13:24:05.000000000 +0000
@@ -1,11 +1,11 @@
 cmake_minimum_required(VERSION 3.16)
-set(KF_VERSION "6.0.0") # handled by release scripts
+set(KF_VERSION "6.3.0") # handled by release scripts
 
 project(KCalendarCore VERSION ${KF_VERSION})
 
 # ECM setup
 include(FeatureSummary)
-find_package(ECM 6.0.0  NO_MODULE)
+find_package(ECM 6.3.0  NO_MODULE)
 set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
 feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
diff -pruN 6.0.0-2/autotests/data/Compat/AppleICal_1.5.ics.ical.fixme 6.3.0-1/autotests/data/Compat/AppleICal_1.5.ics.ical.fixme
--- 6.0.0-2/autotests/data/Compat/AppleICal_1.5.ics.ical.fixme	1970-01-01 00:00:00.000000000 +0000
+++ 6.3.0-1/autotests/data/Compat/AppleICal_1.5.ics.ical.fixme	2024-05-31 13:24:05.000000000 +0000
@@ -0,0 +1 @@
+294 known errors
diff -pruN 6.0.0-2/autotests/data/Compat/KOrganizer_3.1a.ics.ical.fixme 6.3.0-1/autotests/data/Compat/KOrganizer_3.1a.ics.ical.fixme
--- 6.0.0-2/autotests/data/Compat/KOrganizer_3.1a.ics.ical.fixme	1970-01-01 00:00:00.000000000 +0000
+++ 6.3.0-1/autotests/data/Compat/KOrganizer_3.1a.ics.ical.fixme	2024-05-31 13:24:05.000000000 +0000
@@ -0,0 +1 @@
+28 known errors
diff -pruN 6.0.0-2/autotests/data/Compat/MSExchange.ics.ical.fixme 6.3.0-1/autotests/data/Compat/MSExchange.ics.ical.fixme
--- 6.0.0-2/autotests/data/Compat/MSExchange.ics.ical.fixme	1970-01-01 00:00:00.000000000 +0000
+++ 6.3.0-1/autotests/data/Compat/MSExchange.ics.ical.fixme	2024-05-31 13:24:05.000000000 +0000
@@ -0,0 +1 @@
+1 known errors
diff -pruN 6.0.0-2/autotests/data/Compat/Mozilla_1.0.ics.ical.fixme 6.3.0-1/autotests/data/Compat/Mozilla_1.0.ics.ical.fixme
--- 6.0.0-2/autotests/data/Compat/Mozilla_1.0.ics.ical.fixme	1970-01-01 00:00:00.000000000 +0000
+++ 6.3.0-1/autotests/data/Compat/Mozilla_1.0.ics.ical.fixme	2024-05-31 13:24:05.000000000 +0000
@@ -0,0 +1 @@
+24 known errors
diff -pruN 6.0.0-2/autotests/testicalformat.cpp 6.3.0-1/autotests/testicalformat.cpp
--- 6.0.0-2/autotests/testicalformat.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/autotests/testicalformat.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -521,4 +521,35 @@ void ICalFormatTest::testAllDaySchedulin
     QCOMPARE(parsedEvent->dtEnd().date(), event->dtEnd().date());
 }
 
+void ICalFormatTest::testAllDayRecurringUntil()
+{
+    const auto input = QLatin1String(
+        "BEGIN:VCALENDAR\n"
+        "VERSION:2.0\n"
+        "BEGIN:VEVENT\n"
+        "DTSTAMP:20240327T220619Z\n"
+        "CREATED:20240327T191625Z\n"
+        "UID:c89d88b9-810f-4275-9155-8eea2345386b\n"
+        "SEQUENCE:2\n"
+        "LAST-MODIFIED:20240327T220619Z\n"
+        "SUMMARY:Test\n"
+        "RRULE:FREQ=WEEKLY;UNTIL=20240401;BYDAY=WE\n"
+        "EXDATE;VALUE=DATE:20240327\n"
+        "DTSTART;VALUE=DATE:20240327\n"
+        "DTEND;VALUE=DATE:20240328\n"
+        "TRANSP:OPAQUE\n"
+        "END:VEVENT\n"
+        "END:VCALENDAR\n");
+    ICalFormat format;
+    MemoryCalendar::Ptr cal(new MemoryCalendar(QTimeZone::utc()));
+    QVERIFY(format.fromString(cal, input));
+    const auto events = cal->events();
+    QCOMPARE(events.size(), 1);
+
+    const auto event = events[0];
+    auto recurrence = event->recurrence();
+    QVERIFY(recurrence);
+    QCOMPARE(recurrence->endDate(), QDate(2024, 4, 1));
+}
+
 #include "moc_testicalformat.cpp"
diff -pruN 6.0.0-2/autotests/testicalformat.h 6.3.0-1/autotests/testicalformat.h
--- 6.0.0-2/autotests/testicalformat.h	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/autotests/testicalformat.h	2024-05-31 13:24:05.000000000 +0000
@@ -32,6 +32,7 @@ private Q_SLOTS:
     void testIcalFormat();
     void testNonTextCustomProperties();
     void testAllDaySchedulingMessage();
+    void testAllDayRecurringUntil();
 };
 
 #endif
diff -pruN 6.0.0-2/autotests/testicaltimezones.cpp 6.3.0-1/autotests/testicaltimezones.cpp
--- 6.0.0-2/autotests/testicaltimezones.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/autotests/testicaltimezones.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -199,7 +199,10 @@ void ICalTimeZonesTest::parse_data()
     QTest::addColumn<QByteArray>("origTz");
     QTest::addColumn<QByteArray>("expTz");
 
-    QTest::newRow("dummy-western") << QByteArray(VTZ_Western) << QDateTime{} << QByteArray("Test-Dummy-Western") << QByteArray("America/Toronto");
+    if (false) {
+        // TODO Fix this test
+        QTest::newRow("dummy-western") << QByteArray(VTZ_Western) << QDateTime{} << QByteArray("Test-Dummy-Western") << QByteArray("America/Toronto");
+    }
     QTest::newRow("dummy-other") << QByteArray(VTZ_other) << QDateTime{} << QByteArray("Test-Dummy-Other") << QByteArray("UTC+03:00");
     QTest::newRow("dummy-other-dst DST") << QByteArray(VTZ_other_DST) << QDateTime({2017, 03, 10}, {}) << QByteArray("Test-Dummy-Other-DST")
                                          << QByteArray("UTC+03:00");
diff -pruN 6.0.0-2/autotests/testrecurprevious.cpp 6.3.0-1/autotests/testrecurprevious.cpp
--- 6.0.0-2/autotests/testrecurprevious.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/autotests/testrecurprevious.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -17,6 +17,7 @@
 #include <QTextStream>
 #include <QTimeZone>
 
+using namespace Qt::Literals::StringLiterals;
 using namespace KCalendarCore;
 
 static QString dumpTime(const QDateTime &dt, const QTimeZone &viewZone);
@@ -132,9 +133,10 @@ QString dumpTime(const QDateTime &dt, co
         return QString();
     }
     const QDateTime vdt = viewZone.isValid() ? dt.toTimeZone(viewZone) : dt;
-    QString format = QStringLiteral("yyyy-MM-ddThh:mm:ss t");
+    auto out = vdt.toString(u"yyyy-MM-ddThh:mm:ss "_s);
+    out += vdt.timeZone().abbreviation(vdt);
     if (viewZone.isValid()) {
-        format += QStringLiteral(" '%1'").arg(QString::fromUtf8(viewZone.id()));
+        out += ' '_L1 + QString::fromUtf8(viewZone.id());
     }
-    return vdt.toString(format);
+    return out;
 }
diff -pruN 6.0.0-2/autotests/testrecurrence.cpp 6.3.0-1/autotests/testrecurrence.cpp
--- 6.0.0-2/autotests/testrecurrence.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/autotests/testrecurrence.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -17,6 +17,7 @@
 #include <QTextStream>
 #include <QTimeZone>
 
+using namespace Qt::Literals::StringLiterals;
 using namespace KCalendarCore;
 
 static QString dumpTime(const QDateTime &dt, const QTimeZone &viewZone);
@@ -119,11 +120,12 @@ QString dumpTime(const QDateTime &dt, co
         return QString();
     }
     const QDateTime vdt = viewZone.isValid() ? dt.toTimeZone(viewZone) : dt;
-    QString format = QStringLiteral("yyyy-MM-ddThh:mm:ss t");
+    auto out = vdt.toString(u"yyyy-MM-ddThh:mm:ss "_s);
+    out += vdt.timeZone().abbreviation(vdt);
     if (viewZone.isValid()) {
-        format += QStringLiteral(" '%1'").arg(QString::fromUtf8(viewZone.id()));
+        out += ' '_L1 + QString::fromUtf8(viewZone.id());
     } else if (vdt.timeZone().isValid()) {
-        format += QStringLiteral(" '%1'").arg(QString::fromUtf8(vdt.timeZone().id()));
+        out += ' '_L1 + QString::fromUtf8(vdt.timeZone().id());
     }
-    return vdt.toString(format);
+    return out;
 }
diff -pruN 6.0.0-2/debian/changelog 6.3.0-1/debian/changelog
--- 6.0.0-2/debian/changelog	2024-05-14 06:10:23.000000000 +0000
+++ 6.3.0-1/debian/changelog	2024-06-09 12:46:02.000000000 +0000
@@ -1,3 +1,14 @@
+kf6-kcalendarcore (6.3.0-1) experimental; urgency=medium
+
+  [ Patrick Franz ]
+  * New upstream release (6.3.0).
+  * Update build-deps and deps with the info from cmake.
+  * Modernize building by using dh-sequence build-dependencies and
+    dropping manually specified addons and buildsystems for dh.
+  * Remove redundant lintian-overrides.
+
+ -- Patrick Franz <deltaone@debian.org>  Sun, 09 Jun 2024 14:46:02 +0200
+
 kf6-kcalendarcore (6.0.0-2) experimental; urgency=medium
 
   * Team upload.
diff -pruN 6.0.0-2/debian/control 6.3.0-1/debian/control
--- 6.0.0-2/debian/control	2024-05-14 06:09:47.000000000 +0000
+++ 6.3.0-1/debian/control	2024-06-08 10:11:29.000000000 +0000
@@ -8,11 +8,12 @@ Uploaders: Aurélien COUDERC <coucouf@de
 Build-Depends: bison,
                cmake (>= 3.16~),
                debhelper-compat (= 13),
+               dh-sequence-kf6,
+               dh-sequence-pkgkde-symbolshelper,
                doxygen,
-               extra-cmake-modules (>= 6.0.0~),
+               extra-cmake-modules (>= 6.3.0~),
                libical-dev (>= 3.0~),
                libxkbcommon-dev,
-               pkg-kde-tools (>= 0.17.0),
                qt6-base-dev (>= 6.5.0+dfsg~),
                qt6-tools-dev (>= 6.5.0~),
 Standards-Version: 4.7.0
diff -pruN 6.0.0-2/debian/rules 6.3.0-1/debian/rules
--- 6.0.0-2/debian/rules	2024-05-14 06:07:51.000000000 +0000
+++ 6.3.0-1/debian/rules	2024-06-08 10:11:38.000000000 +0000
@@ -4,7 +4,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
 
 %:
-	dh $@ --with kf6,pkgkde_symbolshelper --buildsystem kf6 --without build_stamp
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_QCH=ON
diff -pruN 6.0.0-2/debian/source/lintian-overrides 6.3.0-1/debian/source/lintian-overrides
--- 6.0.0-2/debian/source/lintian-overrides	2024-05-14 06:07:51.000000000 +0000
+++ 6.3.0-1/debian/source/lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-# We do not care about the epoch from kcalcore as this is a new source package and will be
-# co-installable with kcalcore
-kf6-kcalendarcore source: epoch-changed-but-upstream-version-did-not-go-backwards
-kf6-kcalendarcore source: epoch-change-without-comment
diff -pruN 6.0.0-2/debian/upstream/signing-key.asc 6.3.0-1/debian/upstream/signing-key.asc
--- 6.0.0-2/debian/upstream/signing-key.asc	2024-05-14 06:07:51.000000000 +0000
+++ 6.3.0-1/debian/upstream/signing-key.asc	2024-06-07 22:16:45.000000000 +0000
@@ -80,3 +80,24 @@ RUqSlBSJqC4WqZmkB73i16MljvT0+4v2upmud4JK
 oS4=
 =yOFv
 -----END PGP PUBLIC KEY BLOCK-----
+-----BEGIN PGP PUBLIC KEY BLOCK-----
+
+mDMEZZxtxBYJKwYBBAHaRw8BAQdAm/8PHszWuXJwUEeEwowgbi7fIeUDP/r9X14f
+Azm23ay0JU5pY29sYXMgRmVsbGEgPG5pY29sYXMuZmVsbGFAa2RlLm9yZz6IkwQT
+FgoAOxYhBJCpaKyoRTfMJ7meryyN9Yem1KrBBQJlnG8zAhsDBQsJCAcCAiICBhUK
+CQgLAgQWAgMBAh4HAheAAAoJECyN9Yem1KrBeP4BAIKpXwECsL4VtZtg2h6uUCZg
+e6oALUd6LYH6+DAM2cGzAP9nRCB06lOnWPiz3PccQDeGPGTl4fJXM63rXIKvxI8n
+C7QkTmljb2xhcyBGZWxsYSA8bmljb2xhcy5mZWxsYUBnbXguZGU+iJMEExYKADsW
+IQSQqWisqEU3zCe5nq8sjfWHptSqwQUCZZxtxAIbAwULCQgHAgIiAgYVCgkICwIE
+FgIDAQIeBwIXgAAKCRAsjfWHptSqwb/cAQDdwi3Ujltdb58uFEN9Wxvv2a/PmJJr
+v76mHWmXqia0UwD/fpQfF7W6Iv6tEoqE2VQjMdboRqumV2m9lDyB3OPwtg+4MwRl
+nG3EFgkrBgEEAdpHDwEBB0ABCziM0Ive6TFO3hWrLxpYFCti3xUL7fLLdJqIJYHc
+O4h4BBgWCgAgFiEEkKlorKhFN8wnuZ6vLI31h6bUqsEFAmWcbcQCGyAACgkQLI31
+h6bUqsFXfQD9G8xNZ6QbfOeP/ARYPH7xUcc2U4/kPjoP8+R/MRnshPMBANDv6T3y
+BxoNXQRYK65x7ghXOSZcQyBLfVuSQshzf/oBuDgEZZxtxBIKKwYBBAGXVQEFAQEH
+QAOAXtH8j+F4XstbXodRsjUSLSQx3doS6cssY8XiZWZ5AwEIB4h4BBgWCgAgFiEE
+kKlorKhFN8wnuZ6vLI31h6bUqsEFAmWcbcQCGwwACgkQLI31h6bUqsFomwD/Zy41
+I8jssyuukIKsRefmsvFeeMKEJgFp0WuZQaZnKEIBANbtyBSxCOkD+5GYm1cjG6nr
+yPRSi/2EuYie6axT6ZIN
+=Noyp
+-----END PGP PUBLIC KEY BLOCK-----
diff -pruN 6.0.0-2/metainfo.yaml 6.3.0-1/metainfo.yaml
--- 6.0.0-2/metainfo.yaml	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/metainfo.yaml	2024-05-31 13:24:05.000000000 +0000
@@ -1,4 +1,3 @@
-maintainer: winterz
 description: The KDE calendar access library
 tier: 1
 type: functional
diff -pruN 6.0.0-2/src/icalformat_p.cpp 6.3.0-1/src/icalformat_p.cpp
--- 6.0.0-2/src/icalformat_p.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/src/icalformat_p.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -2390,6 +2390,9 @@ QDateTime ICalFormatImpl::readICalDateTi
 {
     //  qCDebug(KCALCORE_LOG);
     //  _dumpIcaltime( t );
+    if (t.is_date) {
+        return QDateTime(QDate(t.year, t.month, t.day), QTime(), utc ? QTimeZone::UTC : QTimeZone::LocalTime);
+    }
 
     QTimeZone timeZone;
     if (icaltime_is_utc(t) || t.zone == icaltimezone_get_utc_timezone()) {
@@ -2417,10 +2420,7 @@ QDateTime ICalFormatImpl::readICalDateTi
         }
         // If Time zone is still invalid, we will use LocalTime as TimeSpec.
     }
-    QTime resultTime;
-    if (!t.is_date) {
-        resultTime = QTime(t.hour, t.minute, t.second);
-    }
+    QTime resultTime(t.hour, t.minute, t.second);
     QDateTime result;
     if (timeZone.isValid()) {
         result = QDateTime(QDate(t.year, t.month, t.day), resultTime, timeZone);
diff -pruN 6.0.0-2/src/icaltimezones.cpp 6.3.0-1/src/icaltimezones.cpp
--- 6.0.0-2/src/icaltimezones.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/src/icaltimezones.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -629,9 +629,9 @@ bool ICalTimeZoneParser::parsePhase(ical
                 r.setStartDt(utcStart);
                 // The end date time specified in an RRULE must be in UTC.
                 // We can not guarantee correctness if this is not the case.
-                if (r.duration() == 0 && r.endDt().timeSpec() != Qt::UTC) {
-                  qCWarning(KCALCORE_LOG) << "UNTIL in RRULE must be specified in UTC";
-                  break;
+                if (r.duration() == 0 && r.endDt().timeZone() != QTimeZone::utc()) {
+                    qCWarning(KCALCORE_LOG) << "UNTIL in RRULE must be specified in UTC";
+                    break;
                 }
                 const auto dts = r.timesInInterval(utcStart, maxTime);
                 for (int i = 0, end = dts.count(); i < end; ++i) {
diff -pruN 6.0.0-2/src/memorycalendar.cpp 6.3.0-1/src/memorycalendar.cpp
--- 6.0.0-2/src/memorycalendar.cpp	2024-02-21 11:23:30.000000000 +0000
+++ 6.3.0-1/src/memorycalendar.cpp	2024-05-31 13:24:05.000000000 +0000
@@ -285,11 +285,16 @@ void MemoryCalendar::Private::insertInci
         }
 
     } else {
-#ifndef NDEBUG
         // if we already have an to-do with this UID, it must be the same incidence,
         // otherwise something's really broken
-        Q_ASSERT(mIncidences[type].value(uid) == incidence);
-#endif
+        qCWarning(KCALCORE_LOG) << "Calendar already contains an incidence of type" << type << "with UID" << uid << ", not inserting it again";
+        const auto existing = mIncidences[type].value(uid);
+        if (existing != incidence) {
+            qCWarning(KCALCORE_LOG) << "The new incidence is not the same as the existing incidence!";
+            qCWarning(KCALCORE_LOG) << "The existing incidence is summary=" << existing->summary() << ", start=" << existing->dtStart();
+            qCWarning(KCALCORE_LOG) << "The new incidence is summary=" << incidence->summary() << ", start=" << incidence->dtStart();
+        }
+        Q_ASSERT(existing == incidence);
     }
 }
 //@endcond
